;As extracted from Davidge DSB-4/6 FD4000 v1.3 BIOS and supporting

;source libraries.



$*M	;list only generated bytes, not macro expansions



false	equ	0

true	equ	not false



test	equ	false



;from PORTDEF.LIB

ver	equ	1

rev	equ	3



msize	equ	64

xtrpg	equ	10

ssize	equ	msize * 4 - xtrpg



	if	test

bias	equ	(ssize - 80) * 256

	else

bias	equ	0		;generate relocatable system

	endif



	if 	false

;ccp	equ	3400h+bias

;bdos	equ	ccp+800h

;bdose	equ	bdos+6

;bios	equ	ccp+1600h



;gocpm	equ	bios+126h

;nlmsg	equ	bios+55eh

	endif



bdosv	equ	5

conout	equ	2



lf	equ	10

cr	equ	13



	MACLIB	Z80



	org	0100h



	jmp	boot

ccp:

	jr	ccp+3

	nop

;

	lspd	oldstk

	ret

;

	ds	16 - $ mod 16	;pad to 16-byte boundary so it

				;looks "right" in a hex dump

;

;data extracted from CPM64.BIN as SAVED following a MOVCPM

;simulate the start of BDOS in Davidge system:

bdos:	db	2ch		;LSB of Mfr Code

cpmver:	db	22		;CP/M version 22->"2.2"

	db	3		;MSB of Mfr Code

cpmser:	db	0,28h,6ah	;CP/M Serial # stored as big-endian

bdose:

	jmp	bdosv

;

gocpm:

	push	h		;push CCP addr

	ret			;and return to it

;

nlmsg:

	push	h		;save msg ptr

	lxi	h,crlf		;point at CRLF

	call	dismsg		;print it

	pop	h		;get message back

dismsg:

	mvi	c,conout	;call CONOUT

	mov	e,m		;char in E

	res	7,e		;clear high bit

	push	h		;save ptr

	call	bdosv		;print it

	pop	h		;get it back

	bit	7,m		;last?

	rnz			;yes, done

	inx	h		;no, bump to next

	jr	dismsg		;and go again



boot:

	sspd	oldstk	;save old stack pointer

	lxi	sp,stktop	;load new stack pointer

;

; compute CP/M Serial #

;

	LDA	BDOS	;get LSB MFR code

	MOV	E,A	;in E

	LDA	BDOS+2	;get MSB of MFR code

	MOV	D,A	;in D

	LXI	H,MFRCD	;HL -> MFR code field

	CALL	H2D2A	;hex->dec->ASCII conversion

	LHLD	BDOS+4	;get BDOS serial # (LSW)

	MOV	D,L	;byte-swap into DE

	MOV	E,H

	LXI	H,SNSTR	;HL -> Ser. # field

	CALL	H2D2A	;hex->dec-ASCII conversion

;

SIGNON:

	LXI	H,SIGNMSG	;HL points to signon msg

	CALL	nlmsg	;print CRLF then message

	LXI	H,ccp	;go here after cold boot

	JMP	gocpm	; to GIDE BIOS

;

H2D2A:

	PUSH	H	;save output string ptr

;

; zero-out field in output string

	XRA	A	;0 in A

	MVI	B,6	;6 bytes in field

snzrlp:

	MOV	M,A	;zero a byte

	INX	H	;bump to next

	DJNZ	snzrlp	;until done all bytes

;

	POPIX		;IX->start of output field

	LXIY	dvsrtbl	;IY->start of divisor table

	XCHG		;dividend in HL

	LXI	D,0	;0 in DE

;

sndvlp:

	MOV	A,D	;0 (later '0') in A

	DCR	A	;prepare quotient (FF/2F)

	LDY	C,0	;LSB of divisor in C

	INR	C	;if end of tbl, FF->00

	JRZ	sndvdn	;brif end of tbl

	DCR	C	;non-0 (wasn't FF), restore divisor

	LDY	B,1	;next byte in B (BC=divisor)

	INXIY

	INXIY		;bump to next divisor

sndvlp1:

	ORA	A	;clear Carry

	INR	A	;++quotient

	DSBC	BC	;HL -= BC

	JRNC	sndvlp1	;while HL >= BC

;

	INR	E	;E=0 at the start and end of this routine

	DCR	E	;nothing uses it

	JRNZ	wtfdtd	;brif E non-0 (never taken)

;

	DAD	B	;Carry, restore remainder

	ORA	A	;set flagz

	JRZ	sndvlp	;brif quotient (A) == 0 (Cy on first DSBC)

			; get next divisor

	CPI	10	;non-0 quotient, >= 10?

	JRNC	wrsnfld	;brif already ASCII (store byte and go again)

	MVI	D,'0'	;A < 10, make ASCII digit

	ORA	D

wrsnfld:

	STX	A,0	;store char in output field

	INXIX		;bump to next char in field

	JR	sndvlp	;continue w/next divisor

;

wtfdtd:

	DCR	E	;--E (this code is never reached)

	JR	sndvlp1	;continue w/same divisor

;

;We get here when we reach the end of the divisor table.

;A=FF if dividend (HL) was 0000, 2F otherwise

sndvdn:

	INR	A	;FF->0 or 2F->30

	RNZ		;if didn't become 0, done

	MVI	A,'0'	;get ASCII zero char

	STX	A,0	;store in output field

	RET

;

dvsrtbl:	;divisors for hex->dec(->ASCII) conversion

	DW	10000, 1000,  100,   10,    1

	DW	0FFFFH	;end of table

;

; port initialization tables

;

SIGNMSG:

	DB	'64k CP/M Vers 2.2  (FD4000 V'

	DB	ver OR '0','.',rev OR '0',')'

        DB      cr,lf,'  Serial # '

MFRCD:	DB	0,0,0,0,0,0	;up to 6 digit Mfr code

	DB	'-'		;dash

SNSTR:	DB	0,0,0,0,0,0	;up to 6 digit Ser. #

CRLF:	DB	cr,lf+80h	;<CR>,<LF>+80h to mark end.

;

OLDSTK:	DS	2

	DS	24

STKTOP:

	END

