;As extracted from Davidge DSB-4/6 FD4000 v1.3 BIOS and supporting

;source libraries.

;Converted to 8080-only code...



$*M	;list only generated bytes, not macro expansions



false	equ	0

true	equ	not false



test	equ	false



;from PORTDEF.LIB

ver	equ	1

rev	equ	3



msize	equ	64

xtrpg	equ	10

ssize	equ	msize * 4 - xtrpg



	if	test

bias	equ	(ssize - 80) * 256

	else

bias	equ	0		;generate relocatable system

	endif



	if 	false

;ccp	equ	3400h+bias

;bdos	equ	ccp+800h

;bdose	equ	bdos+6

;bios	equ	ccp+1600h



;gocpm	equ	bios+126h

;nlmsg	equ	bios+55eh

	endif



bdosv	equ	5

conout	equ	2



lf	equ	10

cr	equ	13



	org	0100h



	jmp	boot

ccp:

	jmp	ccp+3

;

	lhld	oldstk

	sphl

	ret

;

;data extracted from CPM64.BIN as SAVED following a MOVCPM

;simulate the start of BDOS in Davidge system:

bdos:	db	2ch		;LSB of Mfr Code

cpmver:	db	22		;CP/M version 22->"2.2"

	db	3		;MSB of Mfr Code

cpmser:	db	0,28h,6ah	;CP/M Serial # stored as big-endian

bdose:

	jmp	bdosv

;

gocpm:

	push	h		;push CCP addr

	ret			;and return to it

;

nlmsg:

	push	h		;save msg ptr

	lxi	h,crlf		;point at CRLF

	call	dismsg		;print it

	pop	h		;get message back

dismsg:

	mvi	c,conout	;call CONOUT

	mov	a,m		;char in A

	ani	07fh		;clear high bit

	mov	e,a		;char in E

	push	h		;save ptr

	call	bdosv		;print it

	pop	h		;get it back

	mov	a,m		;char in A

	ani	80h		;last?

	rnz			;yes, done

	inx	h		;no, bump to next

	jmp	dismsg		;and go again



boot:

	lxi	h,0		;0 in HL

	dad	sp		;stack pointer in HL

	shld	oldstk		;save old stack pointer

	lxi	sp,stktop	;load new stack pointer

;

; compute CP/M Serial #

;

	LDA	BDOS	;get LSB MFR code

	MOV	E,A	;in E

	LDA	BDOS+2	;get MSB of MFR code

	MOV	D,A	;in D

	LXI	H,MFRCD	;HL -> MFR code field

	CALL	H2D2A	;hex->dec->ASCII conversion

	LHLD	BDOS+4	;get BDOS serial # (LSW)

	MOV	D,L	;byte-swap into DE

	MOV	E,H

	LXI	H,SNSTR	;HL -> Ser. # field

	CALL	H2D2A	;hex->dec-ASCII conversion

;

SIGNON:

	LXI	H,SIGNMSG	;HL points to signon msg

	CALL	nlmsg	;print CRLF then message

	LXI	H,ccp	;go here after cold boot

	JMP	gocpm	; to GIDE BIOS

;

H2D2A:

	MOV	A,D

	ORA	E	;is divdend 0?

	JNZ	h2d2a1	;jump if non-0

	MVI	M,'0'	;put a '0' in field

	RET

h2d2a1:

	PUSH	H	;save output string ptr

;

; zero-out field in output string

	XRA	A	;0 in A

	MVI	B,6	;6 bytes in field

snzrlp:

	MOV	M,A	;zero a byte

	INX	H	;bump to next

	DCR	B	;--B

	JNZ	snzrlp	;until done all bytes

;

	XCHG		;dividend in HL

	LXI	D,dvsrtbl ;DE->divisor table

;

	mov	a,d	;just need a non-0 byte

	sta	lzskp	;flag to skip leading 0s

sndvlp:

	LDAX	D	;get LSB of divisor

	MOV	C,A	;in C

	INX	D	;bump to MSB

	LDAX	D	;get MSB

	ORA	C	;OR in LSB

	MVI	A,0FFh	;prepare quotient

	JNZ	sndvlp0	;jmp if divisor<>0 (not end of tbl)

	pop	H	;get string ptr back

	ret		;and done

sndvlp0:

	PUSH	PSW	;save quotient

	LDAX	D	;get MSB of divisor

	MOV	B,A	;next byte in B (BC=divisor)

	POP	PSW	;get quotient back

	INX	D	;bump to next divisor

sndvlp1:

	ORA	A	;clear Carry

	INR	A	;++quotient

	DAD	B	;HL -= BC

	JC	sndvlp1	;while HL >= BC

;

	PUSH	PSW	;save quotient

	MOV	A,L	;get LSB of divisor

	sub	C

	mov	L,A

	mov	A,H	;MSB of divisor

	sbb	B

	mov	H,A	;no Carry, restore remainder

	POP	PSW	;restore quotient

	ORA	A	;set flagz

	JNZ	wrsnfld	;jump if quotient (A) <> 0

	lda	lzskp	;A==0, get leading-0 skip flag

	ora	a	;set flags

	JNZ	sndvlp	;jump if skipping

wrsnfld:

	ORI	'0'	;make ASCII digit

	XTHL		;swap dividend/string ptr

	MOV	M,A	;store char in output field

	INX	H	;bump to next char in field

	XTHL		;swap back

	XRA	A	;0 in A

	STA	lzskp	;not skipping 0 bytes

	JMP	sndvlp	;continue w/next divisor

;

dvsrtbl:	;divisors for hex->dec(->ASCII) conversion

	DW	-10000, -1000,  -100,   -10,    -1

	DW	0	;end of table

;

; port initialization tables

;

SIGNMSG:

	DB	'64k CP/M Vers 2.2  (FD4000 V'

	DB	ver OR '0','.',rev OR '0',')'

        DB      cr,lf,'  Serial # '

MFRCD:	DB	0,0,0,0,0,0	;up to 6 digit Mfr code

	DB	'-'		;dash

SNSTR:	DB	0,0,0,0,0,0	;up to 6 digit Ser. #

CRLF:	DB	cr,lf+80h	;<CR>,<LF>+80h to mark end.

;

lzskp	ds	1		;leading-0 skip flag

OLDSTK:	DS	2

	DS	24

STKTOP:

	END



